#include <CoreFoundation/CoreFoundation.h>
#include <CoreServices/CoreServices.h> 
#import "Word.h"
#import <Foundation/Foundation.h>

/* -----------------------------------------------------------------------------
   Step 1
   Set the UTI types the importer supports
  
   Modify the CFBundleDocumentTypes entry in Info.plist to contain
   an array of Uniform Type Identifiers (UTI) for the LSItemContentTypes 
   that your importer can handle
  
   ----------------------------------------------------------------------------- */

/* -----------------------------------------------------------------------------
   Step 2 
   Implement the GetMetadataForFile function
  
   Implement the GetMetadataForFile function below to scrape the relevant
   metadata from your document and return it as a CFDictionary using standard keys
   (defined in MDItem.h) whenever possible.
   ----------------------------------------------------------------------------- */

/* -----------------------------------------------------------------------------
   Step 3 (optional) 
   If you have defined new attributes, update the schema.xml file
  
   Edit the schema.xml file to include the metadata keys that your importer returns.
   Add them to the <allattrs> and <displayattrs> elements.
  
   Add any custom types that your importer requires to the <attributes> element
  
   <attribute name="com_mycompany_metadatakey" type="CFString" multivalued="true"/>
  
   ----------------------------------------------------------------------------- */



/* -----------------------------------------------------------------------------
    Get metadata attributes from file
   
   This function's job is to extract useful information your file format supports
   and return it as a dictionary
   ----------------------------------------------------------------------------- */

Boolean GetMetadataForFile(void* thisInterface, 
			   CFMutableDictionaryRef attributes, 
			   CFStringRef contentTypeUTI,
			   CFStringRef pathToFile)
{
    // NSAutoreleasePool쐬܂B
    NSAutoreleasePool*  pool;
    pool = [[NSAutoreleasePool alloc] init];
    
    // ^f[^i[邽߂̎łB 
    // LXgāACocoaŎg₷܂B 
    NSMutableDictionary*    attrs;
    attrs = (NSMutableDictionary*)attributes;
    
    // t@Cf[^̓ǂݍ݂܂B
	NSArray *content = nil;
	int i, count=0;
	NSString *word, *meaning;
	NSMutableString *mutableWord, *mutableMeaning;
	Word *item;
	NSString *path;
	
	path = (NSString *)pathToFile;
	content = [NSKeyedUnarchiver unarchiveObjectWithFile:path];
	count = [content count];

	if ((content == nil) || (count == 0)) {
		return FALSE;
	}

	// ^f[^ƂĐݒ肷f[^̍쐬B
	mutableWord = [NSMutableString string];
	mutableMeaning = [NSMutableString string];

	for (i=0; i<count; i++) {
		item = [content objectAtIndex:i];
		word = [item valueForKey:@"word"];
		meaning = [item valueForKey:@"meaning"];

		[mutableWord appendFormat:@"%@\n", word];
		[mutableMeaning appendFormat:@"%@\n", meaning];
	}
    
    // ޑɁAf[^ݒ肵܂B 
	[attrs setObject:mutableWord forKey:(id)kMDItemTitle];    
	[attrs setObject:mutableMeaning forKey:(id)kMDItemTextContent];
    
    // NSAutoreleasePoolJ܂B
    [pool release];

    return TRUE;
}
